image: amd64/debian:bookworm-slim

before_script:
  - apt update; apt install -y --no-install-recommends fakeroot build-essential git wget openssl libssl-dev ca-certificates libncurses-dev zstd xz-utils flex libelf-dev bison bc debhelper rsync kmod cpio gpg pahole python3
  - wget -O - https://dl.xanmod.org/${CI_CERTS_TOKEN}/certs2.tar.xz | tar -xvJ
  - export lv=$(make -s kernelversion)
  - export xv=$(cat localversion)
  - export rv=0
  - export git=$(git rev-parse --short=7 HEAD)
  - export dv=$(git show -s --date=format:'%Y%m%d' --format=%cd)
  - export jobs=$((2*$(nproc))); echo $jobs
  - pvcmd="cat $KCONFIG_CONFIG | grep 'LOCALVERSION='" && export pv=$(eval $pvcmd | cut -d'"' -f2)
  - export mvcmd="make -j$jobs KDEB_PKGVERSION='$lv$pv$xv-$rv~$dv.g$git' bindeb-pkg 2>&1 | tee ../build-$lv$pv$xv-$rv~$dv.g"$git"_amd64.log && xz -e9 ../build-*$pv*"
  - export avcmd="mkdir -p assets/ && mv ../*$pv* assets/"

variables:
  DEBFULLNAME: "Alexandre Frade"
  DEBEMAIL: "kernel@xanmod.org"
  KDEB_CHANGELOG_DIST: "bookworm"
  KCONFIG_CONFIG: "CONFIGS/xanmod/gcc/config_$psabi"

6.9 x64v1:
  tags: [saas-linux-xlarge-amd64]
  stage: build
  only:
  - branches
  variables:
    psabi: x86-64-v1
  script:
  - eval $mvcmd && eval $avcmd
  artifacts:
    name: "$CI_JOB_NAME~$CI_COMMIT_SHORT_SHA"
    paths:
    - assets/
    exclude:
    - assets/*dbg*
  timeout: 1h

6.9 x64v2:
  tags: [saas-linux-xlarge-amd64]
  stage: build
  only:
  - branches
  variables:
    psabi: x86-64-v2
  script:
  - eval $mvcmd && eval $avcmd
  artifacts:
    name: "$CI_JOB_NAME~$CI_COMMIT_SHORT_SHA"
    paths:
    - assets/
    exclude:
    - assets/*dbg*
  timeout: 1h

6.9 x64v3:
  tags: [saas-linux-xlarge-amd64]
  stage: build
  only:
  - branches
  variables:
    psabi: x86-64-v3
  script:
  - eval $mvcmd && eval $avcmd
  artifacts:
    name: "$CI_JOB_NAME~$CI_COMMIT_SHORT_SHA"
    paths:
    - assets/
    exclude:
    - assets/*dbg*
  timeout: 1h

6.9 x64v4:
  tags: [saas-linux-xlarge-amd64]
  stage: build
  only:
  - branches
  variables:
    psabi: x86-64-v4
  script:
  - eval $mvcmd && eval $avcmd
  artifacts:
    name: "$CI_JOB_NAME~$CI_COMMIT_SHORT_SHA"
    paths:
    - assets/
    exclude:
    - assets/*dbg*
  timeout: 1h
